package com.fp.general.rules.query;

import java.util.List;

import com.fp.base.persistence.util.helper.GeneralDescriptions;
import com.fp.bpm.query.Query;
import com.fp.dto.Response;
import com.fp.dto.query.QueryRequest;
import com.fp.dto.rules.QueryRule;
import com.fp.persistence.pgeneral.menu.TgeneMenuSubLevelTran;

/**
 * Clase que completa el nombre de la transaccion en subniveles
 * 
 * @author scastillo
 */
public class CompleteTransactionSubLevel extends QueryRule {

    /**
     * Metodo que completa el nombre de la transaccion
     * 
     * @param pQueryRequest
     * @return
     * @throws Exception
     */
    @Override
    public QueryRequest process(QueryRequest pQueryRequest) throws Exception {
        Response response = pQueryRequest.getResponse();
        Query qry = new Query();
        qry.process(pQueryRequest);
        List<Object> lobjects = (List<Object>) response.get("TGENEMENUSUBLEVELTRAN");
        for (Object obj : lobjects) {
            TgeneMenuSubLevelTran tgeneMenuSubLevelTran = (TgeneMenuSubLevelTran) obj;
            if ((tgeneMenuSubLevelTran.getPk().getTransactionmodule() != null) && (tgeneMenuSubLevelTran.getPk().getTransactioncode() != null)
                    && (tgeneMenuSubLevelTran.getPk().getTransactionversion() != null)) {
                tgeneMenuSubLevelTran.addAddtionalInfo("name", GeneralDescriptions.getTransactiondesc(tgeneMenuSubLevelTran.getPk()
                        .getTransactionmodule(), tgeneMenuSubLevelTran.getPk().getTransactioncode(), tgeneMenuSubLevelTran.getPk()
                        .getTransactionversion()));
            } else {
                tgeneMenuSubLevelTran.addAddtionalInfo("name", null);
            }
        }
        return pQueryRequest;
    }
}
